=== debian/changelog ===
wcd (5.2.3-1) unstable; urgency=low

  * New upstream release.
  * debian/control
    - (Standards-Version): Update to 3.9.4.

 -- Jari Aalto <jari.aalto@cante.net>  Wed, 31 Oct 2012 08:38:16 +0200

wcd (5.2.2-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright
    - Adjust indenting and years.
  * debian/rules
    - (MAKE_OPTIONS) New. Pass hardened build flags.
    - (override_dh_auto_clean): Remove generated files.

 -- Jari Aalto <jari.aalto@cante.net>  Mon, 10 Sep 2012 08:48:43 +0300
