=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 #   Copyright information
 #
-#	Copyright (C) 2009-2012 Erwin Waterlander
+#	Copyright (C) 2009-2013 Erwin Waterlander
 #	Copyright (C) 2009 Jari Aalto
 #
 #   License
@@ -48,7 +48,7 @@
 
 include version.mk
 
-CC		= gcc
+CC		?= gcc
 STATIC		=
 STRIP		= strip
 
@@ -129,6 +129,7 @@
 
 # Large File Support (LFS)
 LFS             = 1
+DEBUG           = 0
 
 # Enble Unicode for Cygwin
 ifeq ($(findstring CYGWIN,$(shell uname)),CYGWIN)
@@ -183,9 +184,15 @@
 # possible values: ncurses, curses, pdcurses, pdcursesw or <empty>
 
 ifdef UCS
-	CURSES  = ncursesw
+	CURSES = ncursesw
 else
 	CURSES = ncurses
+endif
+
+ifdef CURSES
+ifdef UCS
+EXTRA_OBJ += wcwidth.o
+endif
 endif
 
 ifneq (,$(CURSES))
@@ -205,6 +212,9 @@
 ifneq ($(wildcard $(INCPREFIX)/include/$(CURSES)/curses.h),)
 	INCFLAGS = -I$(INCPREFIX)/include/$(CURSES)
 endif
+ifeq ($(NCURSES_DEBUG), 1)
+	LIB_CURSES  = -l$(CURSES)_g
+endif
 endif
 
 ifeq ($(CURSES),ncursesw)
@@ -241,10 +251,11 @@
 
 ifeq (cygwin,$(OS))
 ifdef ENABLE_NLS
-	LDFLAGS_EXTRA = -lintl -liconv -lmpr -Wl,--enable-auto-import
+	LIBS_EXTRA    = -lintl -liconv -lmpr
 else
-	LDFLAGS_EXTRA = -lmpr -Wl,--enable-auto-import
-endif
+	LIBS_EXTRA    = -lmpr
+endif
+	LDFLAGS_EXTRA = -Wl,--enable-auto-import
 	INSTALL_TARGETS += install-profile
 endif
 
@@ -271,6 +282,7 @@
 
 ifndef OS
 ifeq ($(findstring MSYS,$(shell uname)),MSYS)
+	CC = gcc
 	DEF_UNIX =
 	OS = msys
 endif
@@ -286,7 +298,8 @@
 	# Running under FreeBSD
 ifdef ENABLE_NLS
 	CFLAGS_OS     = -I/usr/local/include
-	LDFLAGS_EXTRA = -lintl -L/usr/local/lib
+	LDFLAGS_EXTRA = -L/usr/local/lib
+	LIBS_EXTRA    = -lintl
 endif
 endif
 
@@ -294,7 +307,8 @@
 	OS = Darwin
 ifdef ENABLE_NLS
 	CFLAGS_OS     = -I/usr/local/include
-	LDFLAGS_EXTRA = -lintl -L/usr/local/lib
+	LDFLAGS_EXTRA = -L/usr/local/lib
+	LIBS_EXTRA    = -lintl
 endif
 endif
 
@@ -307,7 +321,7 @@
 
 ifeq (sun,$(OS))
 	# Running under SunOS/Solaris
-	LDFLAGS_EXTRA = -lintl
+	LIBS_EXTRA = -lintl
 endif
 
 ifndef OS
@@ -337,7 +351,8 @@
 # (often found as /usr/lib/libncurses.a) to the OBJS1 list.
 
 CFLAGS_USER	=
-CFLAGS	= -O2 -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)
+CFLAGS	?= -O2
+CFLAGS  += -Wall -Wextra -Wno-unused-parameter -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)
 
 EXTRA_CFLAGS	= -Ic3po \
 		  $(CFLAGS_VERSION) \
@@ -346,7 +361,8 @@
 		  $(WDEFS) \
 		  $(NLSDEFS) \
 		  $(NCFLAG) \
-		  $(INCFLAGS)
+		  $(INCFLAGS) \
+		  -DDEBUG=$(DEBUG)
 
 ifeq ($(DEBUG), 1)
 	EXTRA_CFLAGS += -g
@@ -366,12 +382,14 @@
 
 LDFLAGS_USER   =
 LDFLAGS		= $(RPM_OPT_FLAGS) \
-	          $(LIB_CURSES) \
-	          $(LIB_UNISTRING) \
 	          $(LDFLAGS_EXTRA) \
 		  $(NLFLAG) \
 		  $(LDFLAG_STATIC) \
 		  $(LDFLAGS_USER)
+
+LIBS = $(LIB_CURSES) \
+       $(LIB_UNISTRING) \
+       $(LIBS_EXTRA)
 
 DEFS_USER   =
 DEFS		= $(DEF_UNIX) $(DEFS_CURSES) $(EXTRA_DEFS) $(DEFS_USER)
@@ -419,14 +437,16 @@
 	@echo "EXTRA_DEFS    = $(EXTRA_DEFS)"
 	@echo "LDFLAGS       = $(LDFLAGS)"
 	@echo "LDFLAGS_EXTRA = $(LDFLAGS_EXTRA)"
+	@echo "LIBS          = $(LIBS)"
 	@echo "CFLAGS        = $(CFLAGS)"
 	@echo "CFLAGS_OS     = $(CFLAGS_OS)"
 	@echo "EXTRA_CFLAGS  = $(EXTRA_CFLAGS)"
+	@echo "DEBUG         = $(DEBUG)"
 	@echo "-- $(PACKAGE) Makefile settings end --"
 
 $(BIN): $(OBJS1)
 	$(MAKE) status
-	$(CC) $(OBJS1) $(LDFLAGS) -o $@
+	$(CC) $(OBJS1) $(LDFLAGS) $(LIBS) -o $@
 
 %.o: %.c
 	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(DEFS) -c $< -o $@
@@ -545,8 +565,3 @@
 	sed -e "s#BINDIR#$(bindir)#" -e "s/PROGRAM/$(BIN)/" -e 's/##//' etc/profile.d/wcd.sh > $(DESTDIR)$(sysconfdir)/profile.d/wcd.sh
 	sed -e "s#BINDIR#$(bindir)#" -e "s/PROGRAM/$(BIN)/" -e 's/##//' etc/profile.d/wcd.csh > $(DESTDIR)$(sysconfdir)/profile.d/wcd.csh
 else
-	sed -e "s#BINDIR#$(bindir)#" -e "s/PROGRAM/$(BIN)/" etc/profile.d/wcd.sh > $(DESTDIR)$(sysconfdir)/profile.d/wcd.sh
-	sed -e "s#BINDIR#$(bindir)#" -e "s/PROGRAM/$(BIN)/" etc/profile.d/wcd.csh > $(DESTDIR)$(sysconfdir)/profile.d/wcd.csh
-endif
-
-# Old versions of install(1) don't support option -D. Use
