=== debian/changelog ===
wcd (5.2.4-1) unstable; urgency=low

  * New upstream release.
  * debian/conrol
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - (X-Upstream-Vcs): New URL.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 29 Aug 2013 07:20:05 +0300
