=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Jari Aalto <jari.aalto@cante.net>
 Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9), libncursesw5-dev, libunistring-dev, ghostscript
 Standards-Version: 3.9.4
-Vcs-Browser: http://git.debian.org/?p=collab-maint/wcd.git
-Vcs-Git: git://git.debian.org/git/collab-maint/wcd.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/wcd.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/wcd.git
 Homepage: http://freshmeat.net/projects/wcd
 
 Package: wcd
